#ifndef CLOUDSHADER_HXX
#define CLOUDSHADER_HXX

#include "Shader.hxx"
 
class CloudShader : public Shader
{
private:
    Vec3f color;

public:
    
    CloudShader(Scene *scene,
            Vec3f color)
    : Shader(scene),color(color)
    {};
    
    Vec3f Shade(Ray &ray)
    {
        // get uv coordinates
        Vec2f uv = ray.hit->GetUV(ray);

        // based on perlin noise do generate clouds
        Vec3f result = color + Vec3f(PerlinNoise2D(uv.x() * 1024.0, uv.y() * 512.0, 0.7, 0.01, 8));
        result = lerp(result, Vec3f(0.9, 0.9, 1.0), pow(1.0 - uv.y(), 12.0));

        return result;
    };
};

#endif
