#ifndef FLATSHADER_HXX
#define FLATSHADER_HXX

#include "Shader.hxx"

class FlatShader : public Shader
{
public:
    Vec3f color;

    FlatShader(Scene *scene, Vec3f color=Vec3f(1.0,1.0,1.0))
        : Shader(scene), color(color)
    {};

    Vec3f Shade(Ray &ray)
    {     
        // results
        Vec3f result = color;

        // for each assigned texture do combine it
        for (unsigned int i=0; i < getTextureCount(); i++)
        {
             result = (Vec4f(result,1) * getTexture(i)->GetTexel(ray.hit->GetUV(ray))).xyz();
        }

        return result;
    };
};

#endif
