#ifndef RANDOMSAMPLEGENERATOR_HXX
#define RANDOMSAMPLEGENERATOR_HXX

#include "SampleGenerator.hxx"

class RandomSampleGenerator : public SampleGenerator 
{
public:

    /**
     * Generatye randomly distributed n samples per pixel
     **/
	void GetSamples(int n, float* u, float* v, float* weight) const
	{
        // do only work on non allocated arrays
        if (u == NULL) return;
        if (v == NULL) return;
        if (weight == NULL) return;

        // compute sample distribution and weight
		for (int i=0;i<n;i++) 
		{
			u[i] = frand();
			v[i] = frand();
			weight[i] = 1.0f/(float)n;
		}
	}

};

#endif
