
#ifndef RAY_HXX
#define RAY_HXX

#include "Vec3f.hxx"

class Primitive;

class Ray
{
public:
    Vec3f      org; // origin
    Vec3f      dir; // direction
    float        t; // current/maximum hit distance
    Primitive *hit; // currently closest primitive
    float       u,v;// barycentric u/v coordinates

    Ray()
    {
        hit = NULL;
        t = Infinity;
        u = v = 0.0;
    }
    
    Ray(const Ray& r)
    {
        org = r.org;
        dir = r.dir;
        t = r.t;
        hit = r.hit;
        u = r.u;
        v = r.v;
    }

};

//inline std::ostream &operator<<(std::ostream &o,const Ray &ray)
//{ o << "Ray[" << ray.org << "+t*" << ray.dir << "]"; return o; }

#endif
