#ifndef __STD_AFX_H_INCLUDED
#define __STD_AFX_H_INCLUDED

#include <vector>
#include <iostream>
#include <utility>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include <assert.h>
#include <limits.h>
#include <float.h>

#include <sys/types.h>
#include <sys/stat.h>

#include <iostream>
#include <fstream>
#include <string.h>
#include <string>
#include <sstream>

#define _strcmp strcmp

#ifndef MIN
#define MIN(a,b) ((a)<(b)?(a):(b))
#define MAX(a,b) ((a)>(b)?(a):(b))
#endif

#define max(a,b) MAX(a,b)
#define min(a,b) MIN(a,b)

#define Epsilon 1E-7f
#define Infinity FLT_MAX


#ifdef _WIN32
double drand48();
#endif

class Vec2f;
class Vec3f;
class Vec4f;

float frand();
float lerp(float a, float b, float f);
Vec2f lerp(const Vec2f& a, const Vec2f& b, float f);
Vec3f lerp(const Vec3f& a, const Vec3f& b, float f);
Vec4f lerp(const Vec4f& a, const Vec4f& b, float f);

//! cosine interpolation
float cosrp(float a, float b, float f);

float Noise2D(int x, int y);
float SmoothNoise2D(float x, float y);
float InterpolatedNoise2D(float x, float y);
float PerlinNoise2D(float x, float y, float persistence = 0.65, float frequency = 0.015, float octaves = 8);

float deg2rad(float f);
float rad2deg(float f);

#endif
